use serde::Deserialize;
use std::env;
use std::fs;

#[allow(dead_code)]
#[derive(Deserialize)]
struct Config {
    listen_addr: String,
    admin_pass: String,
    connection_string: String,
    log_level: Option<String>,
}

fn main() {
    let config_var = env::var("TMTD_CONFIG");
    let config_path = config_var.as_deref().unwrap_or("tmtd.toml");
    let config = fs::read_to_string(config_path).unwrap();
    let cfg: Config = toml::from_str(&config).unwrap();
    fs::write(".env", format!("DATABASE_URL={}", cfg.connection_string)).unwrap();
}
