create table if not exists users(
    id serial primary key,
    username varchar(16) not null unique,
    hash varchar(128) not null
);

create table if not exists org(
    id serial primary key,
    name varchar(32) not null unique
);

create table if not exists boards(
    id serial primary key,
    name varchar(32) not null,
    description varchar(256),
    org integer not null references org(id) on delete cascade
);

create table if not exists categories(
    id serial primary key,
    name varchar(32) not null,
    board integer not null references boards(id) on delete cascade
);

create table if not exists status(
    id serial primary key,
    name varchar(16),
    board integer not null references boards(id) on delete cascade
);


create table if not exists org_members(
    org integer not null references org(id) on delete cascade,
    member integer not null references users(id) on delete cascade
);

create table if not exists org_boards(
    org integer not null references org(id) on delete cascade,
    board integer not null references boards(id) on delete cascade
);


create table if not exists tasks(
    id serial primary key,
    title varchar(128) not null,
    description varchar(32768) not null,
    author integer references users(id) not null,
    assignee integer references users(id),
    category integer not null references categories(id) on delete cascade,
    org integer not null references org(id) on delete cascade,
    status integer not null references status(id) on delete cascade,
    created timestamp not null,
    deadline timestamp
);

create table if not exists task_assigned(
    task integer references tasks(id),
    member integer references users(id)
);

