/*
 * tmtd - Suckless To Do list
 * Copyright (C) 2022 C4TG1RL5
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of  MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

use serde::{Deserialize, Serialize};

#[derive(Deserialize)]
pub struct SortRequest {
    pub request: String,
}

#[derive(Debug, Deserialize)]
pub struct MoveRequest {
    pub request: String,
    pub task_id: u32,
}

#[derive(Debug, Deserialize)]
pub struct Create {
    pub title: String,
    pub assignee: String,
    pub description: String,
}

#[derive(Debug, Serialize)]
pub struct Task {
    pub title: String,
    pub date: String,
    pub status: String,
    pub assignee: String,
    pub description: String,
    pub id: u32,
}

#[derive(Deserialize)]
pub struct Register {
    pub username: String,
    pub password: String,
}
